﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.5
@EndOfDesignText@
Sub Class_Globals
	
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
'	Public AppIconPath As String = "file:///android_asset/icon.png"
	Public AppName As String = "Test App"
	Public appIconFilename As String = "icon.png"
	Public PrivacyURL As String = "https://mindware.mobi/mind-games-privacy-policy/"
	Public adProvidersFilename As String = "ad_technology_provider_privacy_urls.csv" '<<< Download this file from YOUR AdMob Console

	Public appIconPath As String
	Public lang, langCode As String
		
	#if b4i
		Dim WebView1 As WkWebview
	#else
		Dim WebView1 As WebView
	#end if
	
	Private btnBackWeb As B4XView
	
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)

	Root = Root1
	'load the layout to Root

	Dim ah As AHLocale
		ah.Initialize
	
	Dim B4xConsent As B4X_Ad_Consent
	
	langCode = ah.ISOCode.SubString2(0, 2)
	
	If langCode="en" Then 
		lang=""
	Else
		lang="_" & langCode
	End If
	
	appIconPath = WebViewAssetFile(appIconFilename)

	Dim jsonEncoder1 As JSONGenerator
		jsonEncoder1.Initialize(CreateMap("app_name" : AppName, "app_icon": appIconPath, "plat":"Android",  "consent_info" : CreateMap("raw_response":1, "is_request_in_eea_or_unknown":1)))
	
	Dim nestedJSONString As String = jsonEncoder1.ToString
	Dim ConsentDataMap As Map = CreateMap("args" : CreateMap("info" : nestedJSONString))
	
	Dim jsonEncoder As JSONGenerator
		jsonEncoder.Initialize(ConsentDataMap)
		
	Dim jsonString As String = jsonEncoder.ToString
	Log("jsonString "&jsonString)
	B4xConsent.Initialize(Me, Root, lang, jsonString)
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Sub Consent_Response(ConsentString As String)
	LogColor("Consent_Response ConsentString="&ConsentString, Colors.blue)
	
	If ConsentString.Contains("status=personalized") Then
		LogColor("Personalized Ads selected", Colors.Green)
		'Starter.Consent.ConsentState = Starter.Consent.STATE_PERSONALIZED
		'...
		B4XPages.ClosePage(Me)
		
	Else If ConsentString.Contains("status=non_personalized") Then
		LogColor("Non-Personalized Ads selected", Colors.Red)
		'Starter.Consent.ConsentState = Starter.Consent.STATE_NON_PERSONALIZED
		'...
		B4XPages.ClosePage(Me)
		
	Else if ConsentString.Contains("status=ad_free") Then
		LogColor("Pay for ad-free selected", Colors.Magenta)
		'Your code	
		B4XPages.ClosePage(Me)
		
	Else if ConsentString.Contains("status=show_privacy_policy") Then
		LogColor("Show privacy policy", Colors.Green)
		OpenPrivacyPolicy
'   or	OpenPrivacyPolicy2
		
	Else if ConsentString.Contains("status=show_providers") Then
		LogColor("Show providers", Colors.Green)
		ShowProviders
		
	End If
	
End Sub

Sub ShowProviders
	B4XPages.ShowPage("Ad Providers Page")
End Sub

Sub OpenPrivacyPolicy2
	Dim i As Intent
	i.Initialize(i.ACTION_VIEW, PrivacyURL)
	StartActivity(i)
End Sub

Sub OpenPrivacyPolicy	
	Root.LoadLayout("b4xAdConsent")
		
	btnBackWeb.Text = Chr(0xF060)
	btnBackWeb.Visible = True
	
	WebView1.LoadUrl(PrivacyURL)	
		
End Sub


Private Sub btnBackWeb_Click
	WebView1.RemoveView
	btnBackWeb.RemoveViewFromParent
End Sub

Sub WebViewAssetFile (FileName As String) As String
   #if B4J
     Return File.GetUri(File.DirAssets, FileName)
   #Else If B4A
     Dim jo As JavaObject
     jo.InitializeStatic("anywheresoftware.b4a.objects.streams.File")
     If jo.GetField("virtualAssetsFolder") = Null Then
       Return "file:///android_asset/" & FileName.ToLowerCase
     Else
       Return "file://" & File.Combine(jo.GetField("virtualAssetsFolder"), _
       jo.RunMethod("getUnpackedVirtualAssetFile", Array As Object(FileName)))
     End If
   #Else If B4i
     Return $"file://${File.Combine(File.DirAssets, FileName)}"$
   #End If
End Sub